<html>
<head>
<title>OGRE: OgrePlane.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgrePlane.h</h1><a href="OgrePlane_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="comment">// Original free version by:</span>
<a name="l00030"></a>00030 <span class="comment">// Magic Software, Inc.</span>
<a name="l00031"></a>00031 <span class="comment">// http://www.geometrictools.com/</span>
<a name="l00032"></a>00032 <span class="comment">// Copyright (c) 2000, All Rights Reserved</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#ifndef __Plane_H__</span>
<a name="l00035"></a>00035 <span class="preprocessor"></span><span class="preprocessor">#define __Plane_H__</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span>
<a name="l00037"></a>00037 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="preprocessor">#include "<a class="code" href="OgreVector3_8h.html">OgreVector3.h</a>"</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="keyword">namespace </span>Ogre {
<a name="l00042"></a>00042 
<a name="l00053"></a><a class="code" href="classOgre_1_1Plane.html">00053</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>
<a name="l00054"></a>00054     {
<a name="l00055"></a>00055     <span class="keyword">public</span>:
<a name="l00058"></a>00058         <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a> ();
<a name="l00059"></a>00059         <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a> (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>&amp; rhs);
<a name="l00061"></a>00061         <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a> (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkNormal, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fConstant);
<a name="l00062"></a>00062         <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a> (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkNormal, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkPoint);
<a name="l00063"></a>00063         <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a> (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkPoint0, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkPoint1,
<a name="l00064"></a>00064             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkPoint2);
<a name="l00065"></a>00065 
<a name="l00070"></a><a class="code" href="classOgre_1_1Plane.html#a5d44b14d6f032f3e0a26e83589180bc">00070</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1Plane.html#a5d44b14d6f032f3e0a26e83589180bc" title="The &amp;quot;positive side&amp;quot; of the plane is the half space to which the plane normal...">Side</a>
<a name="l00071"></a>00071         {
<a name="l00072"></a><a class="code" href="classOgre_1_1Plane.html#a5d44b14d6f032f3e0a26e83589180bcad112821a6c39f0097136ba5df53052a">00072</a>             NO_SIDE,
<a name="l00073"></a><a class="code" href="classOgre_1_1Plane.html#a5d44b14d6f032f3e0a26e83589180bcc5f2b56ac439b77aad6dfc4031891be5">00073</a>             POSITIVE_SIDE,
<a name="l00074"></a><a class="code" href="classOgre_1_1Plane.html#a5d44b14d6f032f3e0a26e83589180bcaf227c36d02442779fd4600d00580f5e">00074</a>             NEGATIVE_SIDE,
<a name="l00075"></a><a class="code" href="classOgre_1_1Plane.html#a5d44b14d6f032f3e0a26e83589180bc44420e1c49338ae721f298826e164935">00075</a>             BOTH_SIDE
<a name="l00076"></a>00076         };
<a name="l00077"></a>00077 
<a name="l00078"></a>00078         Side getSide (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkPoint) <span class="keyword">const</span>;
<a name="l00079"></a>00079 
<a name="l00084"></a>00084         Side getSide (<span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; rkBox) <span class="keyword">const</span>;
<a name="l00085"></a>00085 
<a name="l00095"></a>00095         Side getSide (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; centre, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; halfSize) <span class="keyword">const</span>;
<a name="l00096"></a>00096 
<a name="l00105"></a>00105         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getDistance (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkPoint) <span class="keyword">const</span>;
<a name="l00106"></a>00106 
<a name="l00108"></a>00108         <span class="keywordtype">void</span> redefine(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkPoint0, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkPoint1,
<a name="l00109"></a>00109             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkPoint2);
<a name="l00110"></a>00110 
<a name="l00112"></a>00112         <span class="keywordtype">void</span> redefine(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkNormal, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkPoint);
<a name="l00113"></a>00113 
<a name="l00121"></a>00121         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> projectVector(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; v) <span class="keyword">const</span>;
<a name="l00122"></a>00122 
<a name="l00132"></a>00132         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> normalise(<span class="keywordtype">void</span>);
<a name="l00133"></a>00133 
<a name="l00134"></a><a class="code" href="classOgre_1_1Plane.html#3f97462d3822f6add8c070048f6c2d92">00134</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> normal;
<a name="l00135"></a><a class="code" href="classOgre_1_1Plane.html#8e7de1712320968bee111002bc2938b8">00135</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> d;
<a name="l00136"></a>00136 
<a name="l00138"></a><a class="code" href="classOgre_1_1Plane.html#06e8f4ea4698c322580c4299f6a12e07">00138</a>         <span class="keywordtype">bool</span> <a class="code" href="namespaceOgre.html#b426b0250db523190d60f4bfe0414499">operator==</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00139"></a>00139 <span class="keyword">        </span>{
<a name="l00140"></a>00140             <span class="keywordflow">return</span> (rhs.<a class="code" href="classOgre_1_1Plane.html#8e7de1712320968bee111002bc2938b8">d</a> == d &amp;&amp; rhs.<a class="code" href="classOgre_1_1Plane.html#3f97462d3822f6add8c070048f6c2d92">normal</a> == normal);
<a name="l00141"></a>00141         }
<a name="l00142"></a><a class="code" href="classOgre_1_1Plane.html#dae7d1d5d43cbe44cd40fc1e86784268">00142</a>         <span class="keywordtype">bool</span> <a class="code" href="namespaceOgre.html#9d8174300d9fd7b766d727c85e11a20f">operator!=</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00143"></a>00143 <span class="keyword">        </span>{
<a name="l00144"></a>00144             <span class="keywordflow">return</span> (rhs.<a class="code" href="classOgre_1_1Plane.html#8e7de1712320968bee111002bc2938b8">d</a> != d &amp;&amp; rhs.<a class="code" href="classOgre_1_1Plane.html#3f97462d3822f6add8c070048f6c2d92">normal</a> != normal);
<a name="l00145"></a>00145         }
<a name="l00146"></a>00146 
<a name="l00147"></a>00147         <a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <span class="keyword">friend</span> std::ostream&amp; operator&lt;&lt; (std::ostream&amp; o, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>&amp; p);
<a name="l00148"></a>00148     };
<a name="l00149"></a>00149 
<a name="l00150"></a><a class="code" href="namespaceOgre.html#4cfa65f236aec1767fc85022e87059a0">00150</a>     <span class="keyword">typedef</span> std::vector&lt;Plane&gt; <a class="code" href="namespaceOgre.html#4cfa65f236aec1767fc85022e87059a0">PlaneList</a>;
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 } <span class="comment">// namespace Ogre</span>
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:54 2008
</p>
</body>
</html>
